/*!
        @file    $Id:: fprop_Standard_lex.h #$

        @brief

        @author  Satoru Ueda <sueda@post.kek.jp> (sueda)
                 $LastChangedBy: namekawa $

        @date    $LastChangedDate:: 2013-04-08 18:00:27 #$

        @version $LastChangedRevision: 860 $
*/

#ifndef FPROP_STANDARD_LEX_INCLUDED
#define FPROP_STANDARD_LEX_INCLUDED

#include "fprop.h"
#include "solver.h"

//! Get quark propagator for Fopr with lexical site index.

/*!
    This is temporary implementation.
                                        [28 Dec 2011 H.Matsufuru]
    (Coding history will be recovered from trac.)
    Redundant argument of fopr is deleted.
                                        [03 Mar 2013 Y.Namekawa]
 */

class Fprop_Standard_lex : public Fprop
{
 public:
  Fprop_Standard_lex(Solver *solver)
    : Fprop(), m_solver(solver) {}

  ~Fprop_Standard_lex() {}

  void set_config(Field *);

  void invert_D(Field&, const Field&, int&, double&);
  void invert_DdagD(Field&, const Field&, int&, double&);

 private:
  Solver *m_solver;
};
#endif
